/*
 * $Id: config.h,v 1.1 90/06/15 21:32:01 tynor Exp $
 *----------------------------------------------------------------------------
 *	FPLAN - Flight Planner
 *	Steve Tynor
 *	tynor@prism.gatech.edu
 *
 *	This program is in the public domain. Permission to copy,
 * distribute, modify this program is hearby given as long as this header
 * remains. If you redistribute this program after modifying it, please
 * document your changes so that I do not take the blame (or credit) for
 * those changes.  If you fix bugs or add features, please send me a
 * patch so that I can keep the 'official' version up-to-date.
 *
 *	Bug reports are welcome and I'll make an attempt to fix those
 * that are reported.
 *
 *	USE AT YOUR OWN RISK! I assume no responsibility for any
 * errors in this program, its database or documentation. I will make an
 * effort to fix bugs, but if you crash and burn because, for example,
 * fuel estimates in this program were inaccurate, it's your own fault
 * for trusting somebody else's code! Remember, as PIC, it's _your_
 * responsibility to do complete preflight planning. Use this program as
 * a flight planning aid, but verify its results before using them.
 *----------------------------------------------------------------------------
 */


/*
 * environment variables for where the databases are:
 */
#define HOME 		"HOME"		/* used to expand ~ */
#define NAV_PUBLIC	"NAV"
#define NAV_PRIVATE	"NAV_PRIVATE"

/*
 * Default directories for the private databases
 */
#ifndef DEFAULT_PVT_DIRECTORY
#ifdef MSDOS
#define DEFAULT_PVT_DIRECTORY	"\\flight"
#else
#define DEFAULT_PVT_DIRECTORY	"~/preflight"
#endif
#endif

/*
 * Default directories for the public databases
 */
#ifndef DEFAULT_PUB_DIRECTORY
#ifdef MSDOS
#define DEFAULT_PUB_DIRECTORY	"\\lib\\flight"
#else
#define DEFAULT_PUB_DIRECTORY	"/usr/local/lib/preflight"
#endif
#endif

/*
 * Default names for the database files
 */
#ifdef MSDOS
#define AIRPORTS_NAME "\\airports.nav"
#define VORS_NAME     "\\vors.nav"
#define COMMA_DOT     "\\comma."
#else
#define AIRPORTS_NAME "/airports.nav"
#define VORS_NAME     "/vors.nav"
#define COMMA_DOT     "/comma."
#endif

#include <stdlib.h>
#include <stdio.h>
