#if defined(__STDC__) || defined(__cplusplus)
#define YYCONST const
#define YYPARAMS(x) x
#define YYDEFUN(name, arglist, args) name(args)
#define YYAND ,
#define YYPTR void *
#else
#define YYCONST
#define YYPARAMS(x) ()
#define YYDEFUN(name, arglist, args) name arglist args;
#define YYAND ;
#define YYPTR char *
#endif
#ifndef lint
YYCONST static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley +Cygnus.28) 01/20/91";
#endif
#define YYBYACC 1
#ifndef YYDONT_INCLUDE_STDIO
#include <stdio.h>
#endif
#ifdef __cplusplus
#include <stdlib.h> /* for malloc/realloc/free */
#endif
#line 2 "fp_yacc.y"
/*
 * $Id: fp_yacc.y,v 2.5 89/11/11 19:17:00 tynor Exp $
 *----------------------------------------------------------------------------
 *	FPLAN - Flight Planner
 *	Steve Tynor
 *	tynor@prism.gatech.edu
 *
 *	This program is in the public domain. Permission to copy,
 * distribute, modify this program is hearby given as long as this header
 * remains. If you redistribute this program after modifying it, please
 * document your changes so that I do not take the blame (or credit) for
 * those changes.  If you fix bugs or add features, please send me a
 * patch so that I can keep the 'official' version up-to-date.
 *
 *	Bug reports are welcome and I'll make an attempt to fix those
 * that are reported.
 *
 *	USE AT YOUR OWN RISK! I assume no responsibility for any
 * errors in this program, its database or documentation. I will make an
 * effort to fix bugs, but if you crash and burn because, for example,
 * fuel estimates in this program were inaccurate, it's your own fault
 * for trusting somebody else's code! Remember, as PIC, it's _your_
 * responsibility to do complete preflight planning. Use this program as
 * a flight planning aid, but verify its results before using them.
 *----------------------------------------------------------------------------
 */

#include "config.h"
#include "wp_info.h"
#include "proto.h"

static char rcsid[] = "$Id: fp_yacc.y,v 2.5 89/11/11 19:17:00 tynor Exp $";

typedef union {
   int			ival;
   double		dval;
   char			*sval;
   WAYPOINT_KIND	kval;
} YYSTYPE;

#line 66 "y.tab.c"
#define TOK_SEMICOLON 257
#define TOK_ASSIGN 258
#define TOK_VIA 259
#define TOK_ALT 260
#define TOK_FROM 261
#define TOK_TO 262
#define TOK_MI 263
#define TOK_NM 264
#define TOK_MPH 265
#define TOK_KTS 266
#define TOK_COMMA 267
#define TOK_REAL 268
#define TOK_INTEGER 269
#define TOK_NAV 270
#define TOK_WIND 271
#define TOK_TAS 272
#define TOK_LPAREN 273
#define TOK_RPAREN 274
#define TOK_FUEL_AMT 275
#define TOK_FUEL_RATE 276
#define TOK_FUEL_USED 277
#define TOK_STRING 278
#define TOK_SYMBOL 279
#define TOK_ATSIGN 280
#define YYERRCODE 256
static YYCONST short yylhs[] = {                                        -1,
    0,   10,   10,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   12,   13,   14,    1,    1,    1,   15,
   16,   17,   18,   19,   20,   21,    3,    4,    8,    8,
    9,    2,    2,    6,    6,    6,    7,    7,    7,    5,
};
static YYCONST short yylen[] = {                                         2,
    1,    0,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    5,    7,    1,    1,    1,    5,
    2,    4,    2,    2,    2,    2,    1,    1,    0,    2,
    1,    1,    1,    2,    1,    2,    2,    1,    2,    1,
};
static YYCONST short yydefred[] = {                                      2,
    0,    0,   18,    0,   17,   19,    0,    0,    0,    0,
    0,    0,    0,    3,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   32,   33,   26,    0,   40,    0,
    0,   21,   23,   24,   25,    0,   31,    0,    0,    0,
   14,    4,    5,    6,    7,    8,    9,   10,   11,   12,
   13,    0,    0,   37,   39,   34,   36,    0,    0,    0,
    0,   22,   28,    0,   30,    0,   20,    0,   15,    0,
   16,
};
static YYCONST short yydgoto[] = {                                       1,
   13,   31,   39,   64,   30,   40,   32,   60,   41,    2,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,
};
static YYCONST short yysindex[] = {                                      0,
    0, -249,    0, -267,    0,    0, -270, -267, -267, -267,
 -267, -267, -254,    0, -252, -241, -238, -221, -219, -215,
 -214, -212, -211, -210,    0,    0,    0, -267,    0, -231,
 -248,    0,    0,    0,    0,    0,    0, -232, -217, -216,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -226, -267,    0,    0,    0,    0, -213, -225, -216,
 -227,    0,    0, -216,    0, -216,    0, -216,    0, -216,
    0,
};
static YYCONST short yyrindex[] = {                                      0,
    0,   54,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -201,    0,    0,    0,    0, -223,    0, -237,    0, -200,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -200,
    0,    0,    0, -200,    0, -200,    0, -200,    0, -200,
    0,
};
static YYCONST short yygindex[] = {                                      0,
    0,   -4,    0,    0,    0,    0,    5,  -31,   -2,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
#define YYTABLESIZE 59
static YYCONST short yytable[] = {                                      27,
   25,   26,   28,   29,   42,   33,   34,   35,   38,    3,
    4,    5,    6,   36,   26,   43,   54,   55,   44,   35,
    7,    8,    9,   52,   37,   10,   11,   12,   66,   35,
   56,   57,   68,   32,   69,   45,   70,   46,   71,   32,
   32,   47,   48,   27,   49,   50,   51,   61,   53,   58,
   59,   37,   65,    1,   63,   38,   29,   62,   67,
};
static YYCONST short yycheck[] = {                                       4,
  268,  269,  273,    8,  257,   10,   11,   12,   13,  259,
  260,  261,  262,  268,  269,  257,  265,  266,  257,  257,
  270,  271,  272,   28,  279,  275,  276,  277,   60,  267,
  263,  264,   64,  257,   66,  257,   68,  257,   70,  263,
  264,  257,  257,  267,  257,  257,  257,  274,  280,  267,
  267,  279,  278,    0,  268,  257,  257,   53,   61,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 280
#if YYDEBUG
static YYCONST char *YYCONST yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"TOK_SEMICOLON","TOK_ASSIGN",
"TOK_VIA","TOK_ALT","TOK_FROM","TOK_TO","TOK_MI","TOK_NM","TOK_MPH","TOK_KTS",
"TOK_COMMA","TOK_REAL","TOK_INTEGER","TOK_NAV","TOK_WIND","TOK_TAS",
"TOK_LPAREN","TOK_RPAREN","TOK_FUEL_AMT","TOK_FUEL_RATE","TOK_FUEL_USED",
"TOK_STRING","TOK_SYMBOL","TOK_ATSIGN",
};
static YYCONST char *YYCONST yyrule[] = {
"$accept : fplan",
"fplan : directives",
"directives :",
"directives : directives directive",
"directive : named_waypoint TOK_SEMICOLON",
"directive : inc_waypoint TOK_SEMICOLON",
"directive : lat_waypoint TOK_SEMICOLON",
"directive : nav_fix TOK_SEMICOLON",
"directive : true_airspeed TOK_SEMICOLON",
"directive : wind TOK_SEMICOLON",
"directive : fuel_amt TOK_SEMICOLON",
"directive : fuel_rate TOK_SEMICOLON",
"directive : fuel_used TOK_SEMICOLON",
"directive : flight_altitude TOK_SEMICOLON",
"named_waypoint : waypoint_kind desig",
"inc_waypoint : waypoint_kind distance optional_string optional_string optional_string",
"lat_waypoint : waypoint_kind latitude TOK_COMMA longitude optional_string optional_string optional_string",
"waypoint_kind : TOK_FROM",
"waypoint_kind : TOK_VIA",
"waypoint_kind : TOK_TO",
"nav_fix : TOK_NAV TOK_LPAREN number TOK_RPAREN desig",
"true_airspeed : TOK_TAS speed",
"wind : TOK_WIND heading TOK_ATSIGN speed",
"fuel_amt : TOK_FUEL_AMT number",
"fuel_rate : TOK_FUEL_RATE number",
"fuel_used : TOK_FUEL_USED number",
"flight_altitude : TOK_ALT number",
"latitude : TOK_REAL",
"longitude : TOK_REAL",
"optional_string :",
"optional_string : TOK_COMMA TOK_STRING",
"desig : TOK_SYMBOL",
"number : TOK_REAL",
"number : TOK_INTEGER",
"distance : number TOK_MI",
"distance : number",
"distance : number TOK_NM",
"speed : number TOK_MPH",
"speed : number",
"speed : number TOK_KTS",
"heading : number",
};
#endif
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#ifndef YYINITDEPTH
#define YYINITDEPTH 200
#endif
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
#ifndef YYMAXSTACKSIZE
#define YYMAXSTACKSIZE 10000
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
YYSTYPE yyval;
YYSTYPE yylval;
static short *yyss;
static YYSTYPE *yyvs;
static int yystacksize;
#define yyfree(x) free(x)
extern int yylex();

static YYPTR
YYDEFUN (yymalloc, (bytes), unsigned bytes)
{
    YYPTR ptr = (YYPTR) malloc (bytes);
    if (ptr != 0) return (ptr);
    yyerror ("yyparse: memory exhausted");
    return (0);
}

static YYPTR
YYDEFUN (yyrealloc, (old, bytes), YYPTR old YYAND unsigned bytes)
{
    YYPTR ptr = (YYPTR) realloc (old, bytes);
    if (ptr != 0) return (ptr);
    yyerror ("yyparse: memory exhausted");
    return (0);
}

static int
#ifdef __GNUC__
__inline__
#endif
yygrow ()
{
    int old_stacksize = yystacksize;
    short *new_yyss;
    YYSTYPE *new_yyvs;

    if (yystacksize == YYMAXSTACKSIZE)
        return (1);
    yystacksize += (yystacksize + 1 ) / 2;
    if (yystacksize > YYMAXSTACKSIZE)
        yystacksize = YYMAXSTACKSIZE;
#if YYDEBUG
    if (yydebug)
        printf("yydebug: growing stack size from %d to %d\n",
               old_stacksize, yystacksize);
#endif
    new_yyss = (short *) yyrealloc ((char *)yyss, yystacksize * sizeof (short));
    if (new_yyss == 0)
        return (1);
    new_yyvs = (YYSTYPE *) yyrealloc ((char *)yyvs, yystacksize * sizeof (YYSTYPE));
    if (new_yyvs == 0)
    {
        yyfree (new_yyss);
        return (1);
    }
    yyss = new_yyss;
    yyvs = new_yyvs;
    return (0);
}
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#if YYDEBUG
#ifdef __cplusplus
extern "C" char *getenv();
#else
extern char *getenv();
#endif
#endif

int
yyparse()
{
    register int yym, yyn, yystate;
    register YYSTYPE *yyvsp;
    register short *yyssp;
    short *yysse;
#if YYDEBUG
    register YYCONST char *yys;

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == 0)
    {
        yyss = (short *) yymalloc (YYSTACKSIZE * sizeof (short));
        if (yyss == 0)
          goto yyabort;
        yyvs = (YYSTYPE *) yymalloc (YYSTACKSIZE * sizeof (YYSTYPE));
        if (yyvs == 0)
        {
            yyfree (yyss);
            goto yyabort;
        }
        yystacksize = YYSTACKSIZE;
    }
    yysse = yyss + yystacksize - 1;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;
    goto yyloop;

yypush_lex:
    yyval = yylval;
    yystate = yytable[yyn];
yypush:
    if (yyssp >= yysse)
    {
        int depth = yyssp - yyss;
        if (yygrow() != 0)
             goto yyoverflow;
        yysse = yyss + yystacksize -1;
        yyssp = depth + yyss;
        yyvsp = depth + yyvs;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    yyn = yysindex[yystate];
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if (yyn != 0
        && ((yyn += yychar), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
        && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyerrflag > 0)  --yyerrflag;
        yychar = (-1);
        goto yypush_lex;
    }
    yyn = yyrindex[yystate];
    if (yyn != 0
        && ((yyn += yychar), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
        && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            yyn = yysindex[*yyssp];
            if (yyn != 0
                && ((yyn += YYERRCODE), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
                && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                goto yypush_lex;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 14:
#line 107 "fp_yacc.y"
{add_named_waypoint (yyvsp[-1].kval, yyvsp[0].sval);}
break;
case 15:
#line 111 "fp_yacc.y"
{add_inc_waypoint (yyvsp[-3].dval, yyvsp[-2].sval, yyvsp[-1].sval, yyvsp[0].sval);}
break;
case 16:
#line 123 "fp_yacc.y"
{add_lat_waypoint (yyvsp[-6].kval, yyvsp[-5].dval, yyvsp[-3].dval, yyvsp[-2].sval, yyvsp[-1].sval, yyvsp[0].sval);}
break;
case 17:
#line 126 "fp_yacc.y"
{yyval.kval = WP_FROM;}
break;
case 18:
#line 127 "fp_yacc.y"
{yyval.kval = WP_VIA;}
break;
case 19:
#line 128 "fp_yacc.y"
{yyval.kval = WP_TO;}
break;
case 20:
#line 132 "fp_yacc.y"
{set_xfix ((int) yyvsp[-2].dval, yyvsp[0].sval);}
break;
case 21:
#line 135 "fp_yacc.y"
{set_tas (yyvsp[0].dval);}
break;
case 22:
#line 139 "fp_yacc.y"
{set_wind (yyvsp[-2].dval, yyvsp[0].dval);}
break;
case 23:
#line 142 "fp_yacc.y"
{set_fuel_amt (yyvsp[0].dval);}
break;
case 24:
#line 145 "fp_yacc.y"
{set_fuel_rate (yyvsp[0].dval);}
break;
case 25:
#line 148 "fp_yacc.y"
{set_extra_fuel_burn (yyvsp[0].dval);}
break;
case 26:
#line 151 "fp_yacc.y"
{set_altitude (yyvsp[0].dval);}
break;
case 27:
#line 154 "fp_yacc.y"
{yyval.dval = degrees_mins_2_decimal (yydval);}
break;
case 28:
#line 157 "fp_yacc.y"
{yyval.dval = degrees_mins_2_decimal (yydval);}
break;
case 29:
#line 160 "fp_yacc.y"
{yyval.sval = (char*) 0;}
break;
case 30:
#line 161 "fp_yacc.y"
{yyval.sval = strdup (yytext);}
break;
case 31:
#line 164 "fp_yacc.y"
{yyval.sval = strdup (yytext);}
break;
case 32:
#line 167 "fp_yacc.y"
{yyval.dval = yydval;}
break;
case 33:
#line 168 "fp_yacc.y"
{yyval.dval = yydval;}
break;
case 34:
#line 171 "fp_yacc.y"
{yyval.dval = yyvsp[-1].dval / MI_PER_NM;}
break;
case 35:
#line 172 "fp_yacc.y"
{yyval.dval = yyvsp[0].dval;}
break;
case 36:
#line 173 "fp_yacc.y"
{yyval.dval = yyvsp[-1].dval;}
break;
case 37:
#line 176 "fp_yacc.y"
{yyval.dval = yyvsp[-1].dval / MI_PER_NM;}
break;
case 38:
#line 177 "fp_yacc.y"
{yyval.dval = yyvsp[0].dval;}
break;
case 39:
#line 178 "fp_yacc.y"
{yyval.dval = yyvsp[-1].dval;}
break;
case 40:
#line 186 "fp_yacc.y"
{yyval.dval = yyvsp[0].dval;}
break;
#line 592 "y.tab.c"
    }
    yyssp -= yym;
    yyvsp -= yym;
    yym = yylhs[yyn];
    yystate = *yyssp;
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    yyn = yygindex[yym];
	 if (yyn != 0
        && ((yyn += yystate), ((unsigned)yyn <= (unsigned)YYTABLESIZE))
        && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    goto yypush;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
