#ifndef PROTO_H
#define PROTO_H
/* Prototypes for fplan
 *
 * Angus Duggan, 8/6/97
 *
 */

#include "wp_info.h"

/* From fp_yacc.[cy] */
extern FILE *yyin;
extern char yytext[];
extern double yydval ;

int yyparse(void);

/* From main.c */
void yyerror(char *);

/* From misc.c */
double decimal_2_degrees_mins(double);
double degrees_mins_2_decimal(double);

/* From db.c */
BOOLEAN open_dbs (void);
BOOLEAN close_dbs (void);
void put_db_summary (FILE *);

/* From compute.c */
void distance_and_heading (double, double, double, double, double *, double *);
BOOLEAN compute_plan (BOOLEAN);
void print_plan (void);

/* From output.c */
void set_output_units (int);
void set_format (int, BOOLEAN);
void put_db (FILE *, DATABASE_INFO *) ;
BOOLEAN lookup_desig (WAYPOINT_KIND, char *, DATABASE_INFO **);

/* From add.c */
void set_brief (BOOLEAN);
void set_fuel_rate (double);
void set_fuel_amt (double);
void set_extra_fuel_burn (double);
void set_altitude (double);
void set_wind (double, double);
void set_tas (double);
void set_xfix (int, char *);

void add_lat_waypoint(WAYPOINT_KIND, double, double, char *, char *, char *) ;
void add_named_waypoint(WAYPOINT_KIND, char *) ;
void add_inc_waypoint(double, char *, char *, char *) ;

/* From reverse.c */
void print_reverse (void);

/* From strings.c */
char *strdup(char *);
char *strtok(char *, char *);
char *index(char *, char);
char *strncpy(char *, const char *, size_t);
char *strcat(char *, const char *);
int strlen(const char *);
int strcmp(const char *, const char *);
char *strcpy(char *, const char *);

#endif /* PROTO_H */
