/* cctopbm.c - convert cclib character to portable bitmap.
 * AJCD 9/8/90
 */

#include <stdio.h>
#include <pbm.h>

main(argc, argv)
     int argc;
     char *argv[];
{
   FILE *ifd;
   register bit **bitmap;
   int size, num, bytes;
   int row, col, mask, bitcnt;
   unsigned char *mem, *ptr;
   
   pm_progname = argv[0];
   
   if (argc != 4)
      pm_usage("cclib size num");

   ifd = pm_openr(argv[1]);

   size = atoi(argv[2]);
   if (size < 1)
      pm_perror("bad size (< 1)");

   num = atoi(argv[3]);
   if (num < 0)
      pm_perror("bad char number (< 0)");

   bytes = size*((size+7)>>3);
   bitmap = pbm_allocarray(size, size);
   ptr = mem = (unsigned char *)malloc(sizeof(unsigned char)*bytes) ;
   if (mem == NULL)
      pm_perror("out of memory");
      
   if (num && fseek(ifd, (long)(num*bytes), 0) != 0)
      pm_perror("character not found");
   if (fread((char *)mem, sizeof(unsigned char), bytes, ifd) != bytes)
      pm_perror("character data unreadable");
   pm_close(ifd);

   bitcnt = 0;
   for (row = 0; row < size; row++) {
      mask = 128;
      for (col = 0; col < size; col++) {
	 if (mask == 0) {
	    ptr++;
	    mask = 128;
	 }
	 if (*ptr & mask)
	    bitcnt += bitmap[row][col] = PBM_BLACK ;
	 else
	    bitcnt += bitmap[row][col] = PBM_WHITE;
	 mask >>= 1;
      }
      ptr++;
   }
   if (bitcnt == PBM_WHITE * size * size) {
      fprintf(stderr, "%s: Empty bitmap\n", pm_progname);
      size = 0;
   }
   pbm_writepbm(stdout, bitmap, size, size) ;
   exit(0);
}
