#ifndef CONNECTS_H
#define CONNECTS_H

/* connects.h
 *
 * Copyright (C) Angus J. C. Duggan, 1998
 *
 * Freely redistributable software. See file LICENSE for details.
 *
 * SMTP Connection handler stream header
 *
 */

typedef char *(QueueNameFn)(char *buffer, long bufsize) ;

/* Ioctl return flags */
enum { STATUS_ESAVE = 0x1, STATUS_ECLIENT = 0x2, STATUS_ESERVER = 0x4,
       STATUS_EMESSAGE = 0x8, STATUS_EAGAIN = 0x10 } ;

enum { CONNECTION_CHANGE } ; /* Ioctls */

/* Debug cookies */
enum { CONNECTION_DEBUG_READ = 0x434f4e52, /* 'CONR' */
       CONNECTION_DEBUG_WRITE = 0x434f4e57, /* 'CONW' */
       CONNECTION_DEBUG_RESPONSE = 0x434f4e41 /* 'CONA' */ } ;

Stream *MakeConnectionStream(char *hostname, Stream *client,
                             QueueNameFn *getname) ;

#endif /* CONNECTS_H */
