#ifndef SMTPSTR_H
#define SMTPSTR_H

/* smtpstr.h
 *
 * Copyright (C) Angus J. C. Duggan, 1998
 *
 * Freely redistributable software. See file LICENSE for details.
 *
 * SMTP stream header
 *
 */

/* SMTP commands. Four-letter names are actual SMTP commands. */
enum { SMTP_OPENED,
       SMTP_HELO, SMTP_MAIL, SMTP_RCPT, SMTP_DATA, SMTP_MESSAGE, SMTP_DOT,
       SMTP_RSET, SMTP_SEND, SMTP_SOML, SMTP_SAML, SMTP_VRFY, SMTP_EXPN,
       SMTP_HELP, SMTP_NOOP, SMTP_QUIT, SMTP_TURN, SMTP_UNKNOWN,
       SMTP_CLOSED } ;

/* Callback function for parsed lines */
typedef struct {
  int (*open)(void *data) ;
  int (*command)(void *data, int type, char *line, long linelen,
                 char *args, long argslen) ;
  int (*error)(void *data, int type, char *line, long linelen) ;
  void (*close)(void *data) ;
} SMTPCallbacks ;

enum { SMTPSTREAM_SUMMARY } ; /* Ioctls */
enum { SMTPSTREAM_DEBUG = 0x534d5450 /* 'SMTP' */ } ; /* Debug cookies */
Stream *MakeSMTPStream(SMTPCallbacks *callbacks, void *passthrough) ;

#endif /* SMTPSTR_H */
