/* bodystr.c $Id: bodystr.c,v 1.1.1.1 1999/10/24 07:06:53 angus Exp $
 *
 * Copyright (C) Angus J. C. Duggan, 1997
 *
 * Freely redistributable software. See file LICENSE for details.
 *
 * Message body streams
 */

#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#include <string.h>
#include <assert.h>

#include "streams.h"
#include "streami.h"

/*****************************************************************************/

/* Body stream is for reading messages bodies. It uses a line-buffered
   underlying streams to read lines after first <CRLF>. */
Stream *MakeBodyStream(Stream *under)
{
  Stream *this = MakeHeadStream(under) ;

  /* Throw away headers */
  if ( this != NULL ) {
    char *line ;
    long rbytes ;

    do {
      rbytes = ReadStream(this, &line, 0) ;
    } while ( rbytes > 0 ) ;

    DestroyStream(this) ;

    if ( rbytes == 0 )
      this = under ;
    else
      this = NULL ;
  }

  return this ;
}

/*
 * $Log: bodystr.c,v $
 * Revision 1.1.1.1  1999/10/24 07:06:53  angus
 * Initial CVS import
 *
 */
