#ifndef AJCD_STREAMI_H
#define AJCD_STREAMI_H
/* stream_i.h $Id: streami.h,v 1.1.1.1 1999/10/24 07:06:53 angus Exp $
 *
 * Copyright (C) Angus J. C. Duggan, 1997-1998
 *
 * Freely redistributable software. See file LICENSE for details.
 *
 * Support for streams implementation files. Provides definitions for
 * GetLastError() and SetLastError() for compiling on non-Win32.
 */

#ifndef WIN32
#define GetLastError() errno
#define SetLastError(_e) do { errno = (_e); } while (0)

#define ERROR_SUCCESS 0 /* Microsoft seems to think that success is an error */
#define ERROR_INVALID_PARAMETER EINVAL
#define ERROR_NOT_ENOUGH_MEMORY ENOMEM
#define ERROR_ACCESS_DENIED EACCESS
#define ERROR_IO_DEVICE EIO
#endif

long IoctlStreamArgs(Stream *this, long op, va_list args) ;

/*
 * $Log: streami.h,v $
 * Revision 1.1.1.1  1999/10/24 07:06:53  angus
 * Initial CVS import
 *
 */
#endif /* end of streami.h */
